> This page is for Taurus PROTECT, version v3.38.
> For other versions, use one of these documentation indexes:
> - v3.58 (default): https://taurushq.ferndocs.com/protect-capital/v3.58/llms.txt
> - v3.56: https://taurushq.ferndocs.com/protect-capital/v3.56/llms.txt
> - v3.54: https://taurushq.ferndocs.com/protect-capital/v3.54/llms.txt
> - v3.52: https://taurushq.ferndocs.com/protect-capital/v3.52/llms.txt
> - v3.50: https://taurushq.ferndocs.com/protect-capital/v3.50/llms.txt
> - v3.48: https://taurushq.ferndocs.com/protect-capital/v3.48/llms.txt
> - v3.46: https://taurushq.ferndocs.com/protect-capital/v3.46/llms.txt
> - v3.44: https://taurushq.ferndocs.com/protect-capital/v3.44/llms.txt
> - v3.42: https://taurushq.ferndocs.com/protect-capital/v3.42/llms.txt
> - v3.40: https://taurushq.ferndocs.com/protect-capital/v3.40/llms.txt
> - v3.38: https://taurushq.ferndocs.com/protect-capital/v3.38/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://taurushq.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://taurushq.ferndocs.com/_mcp/server.

# List whitelisted addresses

GET https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses

This endpoint returns a list of whitelisted addresses

Reference: https://taurushq.ferndocs.com/protect-capital/reference/whitelisted-addresses/list

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Query parameters

- `limit` (string, optional) — Return maximum `limit` items for a query; Max 100.
- `offset` (string, optional) — Start retrieving items starting at `offset` id
- `addressType` (string, optional) — Can be one of the following: `individual`, `exchange`, `baker`, `stakepool`, `contract`, `validator`, node
- `query` (string, optional) — Will find a match in any part of the value. Filter applies to the following fields: `customerid`, `address`, `blockchain`, `label`, `memo`, `addresstype`
- `exchangeAccountIds` (list of string, optional) — Array containing the list of IDs for exchange accounts
- `tagIDs` (list of string, optional) — Filter addresses with a 'OR' combination of tag IDs
- `allowedForAddressId` (string, optional) — Filter addresses allowed to receive funds from this address id
- `allowedForWalletId` (string, optional) — Filter addresses allowed to receive funds from this wallet id. Will be ignored if allowedForAddressId is filled
- `blockchain` (string, optional) — Filter on the blockchain of the WLA.
- `includeForApproval` (boolean, optional) — bool; If true, include also addresses waiting for approval in the results.
- `addresses` (list of string, optional) — Filter on the specific addresses to return. This field is using the blockchain's native address syntax
- `network` (string, optional) — Name of the blockchain network, eg. `mainnet`, `testnet`, or `sepolia`
- `ids` (list of string, optional) — List of IDs to return
- `tnParticipantID` (string, optional) — uuid; UUID of the Taurus Network participant to whom the address belongs
- `scoreFilter.scoreProvider` (string, optional) — Specify the score provider to filter on, or empty.Each provider has associated filter parameters that can be set.Supported values: 'scorechain', 'coinfirm', 'chainalysis', 'elliptic', 'trmlabs'
- `scoreFilter.scorechainFilters.scoreInBelow` (string, optional) — Filter addresses under a Scorechain incoming score threshold.
- `scoreFilter.scorechainFilters.scoreOutBelow` (string, optional) — Filter addresses under a Scorechain outgoing score threshold.
- `scoreFilter.scorechainFilters.scoreExclusive` (boolean, optional) — By default when both Scorechain scores scoreInBelow and scoreOutBelow are provided, it returns the addresses matching (scoreInBelow AND scoreOutBelow). When scoreExclusive is set to true, it will return the addresses matching (scoreInBelow OR scoreOutBelow).
- `scoreFilter.coinfirmFilters.scoreGreater` (string, optional) — Filter addresses with a Coinfirm C-score above threshold.
- `scoreFilter.chainalysisFilters.scoreGreater` (string, optional) — Filter addresses with a Chainalysis risk score above threshold.
- `scoreFilter.ellipticFilters.scoreGreater` (string, optional) — Filter addresses with an Elliptic risk score above threshold.
- `scoreFilter.trmlabsFilters.scoreGreater` (string, optional) — Filter addresses with an TRM Labs risk score above threshold.
- `lastIncomingTxFromWhitelistedAddress` (datetime, optional) — Filtered addresses with the last incoming transaction older than lastIncomingTransactionDate won't appear in the result. The default value is never
- `contractTypes` (list of string, optional) — Filter addresses by multiple Contract Types. Can be any of: `GENERIC`, `CMTA20`, `CMTA20-KYC`, `CMTA20-RULEENGINE`, `CMTAT`, `ERC20`, `DEFI`, `ERC2771-PROXY-ADMIN`, `TERC1155A`, `GSN_FORWARDER`, `OPEN_ZEPPELIN_FORWARDER`, `TAURUS_CONTRACT_CREATOR`, `SMARTPY-FA2`, `SMARTPY-FA12`, `ASA`, `FIGMENT_STAKING`
- `attributeFiltersJson` (string, optional) — A JSON representation of a list of AttributeFilter objects. The filters are combined with an OR operator.
- `exchangeAccountId` (string, optional) — **Deprecated:** Use exchangeAccountIds instead
- `currency` (string, optional) — **Deprecated:** Use `blockchain` instead
- `scoreProvider` (string, optional) — **Deprecated:** Use `scoreFilter` instead. Can be either of the following: `scorechain`, `coinfirm`, `chainalysis`, `elliptic`, `trmlabs`
- `scoreInBelow` (string, optional) — numeric; **Deprecated:** Use `scoreFilter` instead
- `scoreOutBelow` (string, optional) — numeric; **Deprecated:** Use `scoreFilter` instead
- `scoreExclusive` (boolean, optional) — **Deprecated:** Use `scoreFilter` instead
- `rulesContainerNormalized` (boolean, optional) — **Deprecated:** Normalize rules containers in its own object
- `coinfirmScoreGreater` (string, optional) — **Deprecated:** Use `scoreFilter` instead
- `chainalysisScoreGreater` (string, optional) — **Deprecated:** Use `scoreFilter` instead
- `contractType` (string, optional) — **Deprecated:** Use `contractTypes` instead

## Response

### 200

A successful response.

- `result` (list of tgvalidatordSignedWhitelistedAddressEnvelope, optional)
- `totalItems` (string, optional)
- `rulesContainers` (list of tgvalidatordHashRulesContainer, optional)

## Errors

### 400 Bad Request Error

Bad Request: indicates that the server cannot or will not process the request due to something that is perceived to be a client error (for example, malformed request syntax, invalid request message framing, or deceptive request routing)

- `any`

### 401 Unauthorized Error

Unauthorized: indicates that the client request has not been completed because it lacks valid authentication credentials for the requested resource

- `any`

### 403 Forbidden Error

Forbidden: indicates that the server understands the request but refuses to authorize it

- `any`

### 404 Not Found Error

Not Found: indicates that the server cannot find the requested resource

- `any`

### 500 Internal Server Error

Internal Server Error: indicates that the server encountered an unexpected condition that prevented it from fulfilling the request

- `any`

### 503 Service Unavailable Error

Service Unavailable: indicates that the server is not ready to handle the request.

- `any`

## Types

### tgvalidatordSignedWhitelistedAddressEnvelope

- `id` (string, optional)
- `tenantId` (string, optional)
- `signedAddress` (tgvalidatordSignedWhitelistedAddress, optional)
- `metadata` (tgvalidatordMetadata, optional)
- `action` (string, optional)
- `scores` (list of tgvalidatordScore, optional)
- `trails` (list of tgvalidatordTrail, optional)
- `rulesContainer` (string, optional)
- `rule` (string, optional)
- `approvers` (tgvalidatordApprovers, optional)
- `attributes` (list of tgvalidatordWhitelistedAddressAttribute, optional)
- `rulesContainerHash` (string, optional)
- `blockchain` (string, optional)
- `status` (string, optional)
- `network` (string, optional)
- `visibilityGroupID` (string, optional)
- `tnParticipantID` (string, optional)

### tgvalidatordHashRulesContainer

- `hash` (string, optional)
- `rulesContainer` (string, optional)

### tgvalidatordSignedWhitelistedAddress

- `signatures` (list of tgvalidatordWhitelistSignature, optional)
- `payload` (string, optional)

### tgvalidatordMetadata

- `hash` (string, optional)
- `payload` (any, optional)
- `payloadAsString` (string, optional)

### tgvalidatordScore

- `id` (string, optional)
- `provider` (string, optional)
- `type` (string, optional)
- `score` (string, optional)
- `updateDate` (datetime, optional)

### tgvalidatordTrail

- `id` (string, optional)
- `userId` (string, optional)
- `externalUserId` (string, optional)
- `action` (string, optional)
- `comment` (string, optional)
- `date` (datetime, optional)

### tgvalidatordApprovers

- `parallel` (list of tgvalidatordParallelApproversGroups, optional)

### tgvalidatordWhitelistedAddressAttribute

- `id` (string, optional)
- `key` (string, optional)
- `value` (string, optional)
- `contentType` (string, optional)
- `owner` (string, optional)
- `type` (string, optional)
- `subtype` (string, optional)
- `isfile` (boolean, optional)

### tgvalidatordWhitelistSignature

- `signature` (tgvalidatordWhitelistUserSignature, optional)
- `hashes` (list of string, optional)

### tgvalidatordParallelApproversGroups

- `sequential` (list of tgvalidatordApproversGroup, optional)

### tgvalidatordWhitelistUserSignature

- `userId` (string, optional)
- `signature` (string, optional)
- `comment` (string, optional)

### tgvalidatordApproversGroup

- `externalGroupID` (string, optional)
- `minimumSignatures` (long, optional)

## Examples

**Response**

```json
{
  "result": [
    {
      "id": "string",
      "tenantId": "string",
      "signedAddress": {
        "signatures": [
          {
            "signature": {
              "userId": "string",
              "signature": "string",
              "comment": "string"
            },
            "hashes": [
              "string"
            ]
          }
        ],
        "payload": "string"
      },
      "metadata": {
        "hash": "string",
        "payloadAsString": "string"
      },
      "action": "string",
      "scores": [
        {
          "id": "string",
          "provider": "string",
          "type": "string",
          "score": "string",
          "updateDate": "2024-01-15T09:30:00Z"
        }
      ],
      "trails": [
        {
          "id": "string",
          "userId": "string",
          "externalUserId": "string",
          "action": "string",
          "comment": "string",
          "date": "2024-01-15T09:30:00Z"
        }
      ],
      "rulesContainer": "string",
      "rule": "string",
      "approvers": {
        "parallel": [
          {
            "sequential": [
              {
                "externalGroupID": "string",
                "minimumSignatures": 1
              }
            ]
          }
        ]
      },
      "attributes": [
        {
          "id": "string",
          "key": "string",
          "value": "string",
          "contentType": "string",
          "owner": "string",
          "type": "string",
          "subtype": "string",
          "isfile": true
        }
      ],
      "rulesContainerHash": "string",
      "blockchain": "string",
      "status": "string",
      "network": "string",
      "visibilityGroupID": "string",
      "tnParticipantID": "string"
    }
  ],
  "totalItems": "string",
  "rulesContainers": [
    {
      "hash": "string",
      "rulesContainer": "string"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://your-protect-instance.example.com/api/rest/v1/whitelists/addresses")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```